#!/usr/bin/wish -f

# set DIR /usr/local/lib/equlib

# This is equ_gui - rel. 1.0  1/05/2003
#                       By  M. Prencipe

# set here the operative system

# set OS Unix
set OS DOS

# For DOS/Win systems, set here the directory containing 
# the library directory equlib (in "Unix fashion")

set DIR C:/equiv/equlib 

###########################
set DIRH $DIR/winhelp

global OS
global DIR DIRH
global pos
global AutoSave
global font
global font_dos
global flag_i
global cmd
global typesymm
global cond
global edw edh
global color
global Win
global console_move
global console_line
global output_line
global wdir olddir
global verbose
global autoload
global state
global printer
global hyper
global exp_dir
global cond_flag
global elide_option
global winpos outoffset helpoffset winoffset miscoffset sbarpos miscpos
global hishelp counthelp backhelp


set flag_i 0
set typesymm 0
set cond(dir) 1          
set cond(and) 0           
set pflag 0
set pos end
set cond_flag 0
set olddir [pwd]
set hishelp {}
set counthelp 0
set backhelp 0
set helpflag 0

if {$OS == "Unix"} {
    source $DIR/reference
   } else {source $DIR/refer}

source $cmd(equguirc)

set winpos "+$x_pos+$y_pos"
set hyper {hand2 white}
if {$OS == "DOS"} {set font $font_dos; set state disabled; set hyper hand1}

set type_to_color {efg ebg ofg obg hfg hbg}

foreach col $type_to_color {
   set color($col) [lindex $color_default [lsearch -exact $type_to_color $col]]
   }

source $cmd(equproc)
source $cmd(smartproc)
source $cmd(console)
source $cmd(search)
source $cmd(prochelp)
if {[file exists .equguirc] == 1} {FileRc}

file copy -force $DIR/symm.inp $wdir/symm.inp

wm geometry . $winpos

set sbarpos [NewPosition sbar]
set miscpos [NewPosition misc]

frame .eq  -width 12c -height 8c ;#main Equiv window
wm title . "GUI Equiv"
pack .eq

#Configure topbar
frame .tbar -relief raised -bd 2
pack .tbar  -in .eq -side top -expand true -fill x

menubutton .tbar.help -text Help -menu .tbar.help.menu -underline 0
menubutton .tbar.file -text File -menu .tbar.file.menu -underline 0
menubutton .tbar.edit -text Edit -menu .tbar.edit.menu -underline 0
menubutton .tbar.action -text Action -menu .tbar.action.menu -underline 2
menubutton .tbar.config -text Config -menu .tbar.config.menu -underline 0

label .tbar.datafile -text ""

if {[file exists $wdir/DATA.INP] == 1} {
   .tbar.datafile configure -foreground blue -text "Data File: DATA.INP"
   } else {
   .tbar.datafile configure -foreground red \
         -text "No data file! Use \"Copy hkl\""
   }
 
pack .tbar.datafile -side left -anchor w -padx 5

frame .tbar.buttons
checkbutton .tbar.buttons.save -text "AutoSave" -variable AutoSave -onvalue 1 -offvalue 0 \
            -command {
                  set msg "AutoSave enabled\n"
                  if {$AutoSave == 0} {set msg "AutoSave disabled\n"}
                  catch {ConsoleWrite "general" $msg} 
                      }
checkbutton .tbar.buttons.load -text "AutoLoad" -variable autoload -onvalue 1 -offvalue 0 \
            -command {
                  set msg "AutoLoad enabled\n"
                  if {$autoload == 0} {set msg "AutoLoad disabled\n"}
                  catch {ConsoleWrite "general" $msg}
                  if {$autoload == 1} {
                    if {[file exists $wdir/info.inp] == 1} {
                       set openf $wdir/info.inp
                       .ed delete 1.0 end
                        set fid [open $openf r]
                        while {![eof $fid]} {
                           .ed insert end [read $fid 1000]
	                }    
                        close $fid

                        .ed mark set insert 1.0

                         set msg "Board: loaded file $openf\n"
                         catch {ConsoleWrite "general" $msg}    
                    }
                   }   
                  }

pack .tbar.help .tbar.file .tbar.edit .tbar.action .tbar.config -in .tbar -side right \
            -fill x 
pack .tbar.buttons -side right -padx 20
pack .tbar.buttons.save .tbar.buttons.load -side right -padx 5

menu .tbar.file.menu
.tbar.file.menu add command -label "Working directory" -accelerator "Ctrl+w" -command {WorkDir}
.tbar.file.menu add command -label Open -command OpenFile
.tbar.file.menu add command -label Save -command SaveFile
.tbar.file.menu add command -label "Save as" -command SaveAsFile
.tbar.file.menu add command -label Merge -state $state -command Merge
.tbar.file.menu add command -label Quit -accelerator "Ctrl+q" -command exit

menu .tbar.edit.menu
.tbar.edit.menu add radiobutton -label "Top Insert" -variable pos -value 1.0 \
     -command {
               set msg "Board: top insert\n"
               catch {ConsoleWrite "general" $msg}
              }
.tbar.edit.menu add radiobutton -label "Bottom Insert" -variable pos -value end \
    -command {
               set msg "Board: bottom insert\n"
               catch {ConsoleWrite "general" $msg}
              }
.tbar.edit.menu add separator
.tbar.edit.menu add command -label "Clear Board" -accelerator "Ctrl+c" -command {ResetEditor}
.tbar.edit.menu add command -label "Close Console" -command {destroy .console}
.tbar.edit.menu add command -label "Open Console" \
                            -command "catch {OpenConsole}" 
.tbar.edit.menu add command -label "Clear Console" -command {ConsoleClear}

menu .tbar.help.menu 
.tbar.help.menu add command -label "About GUI Equiv" -command {Information}
.tbar.help.menu add separator

if {$help_type != "MSIE"} {
   .tbar.help.menu add command -label "General help" -command {ViewHelp}
} else {
   .tbar.help.menu add command -label "General help" -command { exec $exp_com $DIR/help.html & }
}

.tbar.help.menu add command -label "GUI Equiv help" -command {GuiHelp}
.tbar.help.menu add command -label "Tutorial" -command {Tutorial}

menu .tbar.action.menu
.tbar.action.menu add command -label Fill  -command Fill 
.tbar.action.menu add command -label Reset -command Reset
.tbar.action.menu add separator
.tbar.action.menu add command -label Compute -command Compute

menu .tbar.config.menu
.tbar.config.menu add cascade -label "Dimensions" -menu .tbar.config.menu.dim
.tbar.config.menu add command -label "Fonts" -command {Fonts} -state $state
.tbar.config.menu add cascade -label "Colors" -menu .tbar.config.menu.colors -state $state
.tbar.config.menu add checkbutton -label "Verbose" -variable verbose -onvalue 1 -offvalue 0
.tbar.config.menu add separator
.tbar.config.menu add command -label "Fix position" -command {WindowPosition}
.tbar.config.menu add command -label "Save configuration" -command FixConfiguration
.tbar.config.menu add command -label "Reset Configuration" -command {ConfigReset}

menu .tbar.config.menu.dim -tearoff false
.tbar.config.menu.dim add command -label "Board Dimensions" -command {Dimensions}
.tbar.config.menu.dim add command -label "Console lines" -command {ConsoleLine}
.tbar.config.menu.dim add command -label "Output lines" -command {OutputLine}


menu .tbar.config.menu.colors -tearoff false
.tbar.config.menu.colors add command -label "Editor Board" -command {set Win "Edit"; Color}
.tbar.config.menu.colors add command -label "Output Window" -command {set Win "Output"; Color}
.tbar.config.menu.colors add command -label "Help Windows" -command {set Win "Help"; Color}

#Configure text editor
frame .edq
text .ed  -width $edw -height $edh -bg $color(ebg) -foreground $color(efg) -font $font \
          -relief sunken -yscrollcommand ".ys set" 
.ed configure -insertbackground white
scrollbar .ys -command ".ed yview"

pack .edq -in .eq -after .tbar  -fill y -fill x -expand true
pack .ys -in .edq -side right -fill y 
pack .ed -in .edq -side left -fill y -fill x -expand true


OpenConsole

#Starting messages to console
set console_move 1
set msg "GUI_Equiv Started - Rel. 1.0 1/05/03\nBy M. Prencipe\n\nEquiv directory $dist_lib
Working directory $wdir\n\n"
catch {ConsoleWrite "main" $msg} 

set console_move 1
if {[file exists .equguirc] == 1} {
     set msg "Local configuration file .equguirc read:\n"
     catch {ConsoleWrite "conf" $msg}
} else {
     set msg "Using configuration defaults\n"
     catch {ConsoleWrite "general" $msg}
}

if {$autoload == 1} {
   if {[file exists $wdir/info.inp] == 1} {
        set openf $wdir/info.inp
       .ed delete 1.0 end
        set fid [open $openf r]
        while {![eof $fid]} {
          .ed insert end [read $fid 1000]
	      }    
        close $fid

       .ed mark set insert 1.0

       set msg "Board: loaded file $openf\n"
       catch {ConsoleWrite "general" $msg}    
    }
}

#Configure sidebar
frame .sbar -bd 2 -relief raised
label .sbar.label -bd 4 -text "Processing" -width 15 -foreground "dark green"

menubutton .sbar.setup -text Setup -relief raised -width 12 -menu .sbar.setup.menu -underline 0
menubutton .sbar.file -text File -relief raised -width 12  -menu .sbar.file.menu -underline 1
menubutton .sbar.ana -relief raised -text Analysis -width 12 -menu .sbar.ana.menu -underline 0
menubutton .sbar.printing -relief raised -text "Printing Options" -width 12 \
            -menu .sbar.printing.menu -underline 0
menubutton .sbar.sel -relief raised -text Selection -width 12 -menu .sbar.sel.menu -underline 2
menubutton .sbar.dele -relief raised -text Delete -width 12 -menu .sbar.dele.menu -underline 0
menubutton .sbar.misc -relief raised -text Misc -width 12 -menu .sbar.misc.menu -underline 0
menubutton .sbar.def -relief raised -text "Build Defaults" -width 12 -menu .sbar.def.menu \
           -underline 0 

pack .sbar -in .eq -side left -after .tbar -fill y
pack .sbar.label -in .sbar -side top -pady 10
pack .sbar.setup  .sbar.file .sbar.ana .sbar.sel .sbar.printing .sbar.dele .sbar.misc \
     -in .sbar -side top -padx 10 -pady 5
pack .sbar.def -in .sbar -side bottom -padx 10 -pady 40 -fill y

menu .sbar.setup.menu
.sbar.setup.menu add command -label "Title" -command {Title}
.sbar.setup.menu add command -label "Symmetry" -command {SetSymmetry} 
.sbar.setup.menu add command -label "Cell" -command {Cell}
.sbar.setup.menu add command -label "Set to Zero" -command {.ed insert $pos "SETZ\n"}
.sbar.setup.menu add command -label "Generates hkl" -command Gener_hkl
.sbar.setup.menu add command -label "Matrix" -command Matrix

menu .sbar.file.menu
.sbar.file.menu add command -label "Default theta" -command {DefaultTheta}
.sbar.file.menu add command -label "Select theta range" -command {ThetaRange}
.sbar.file.menu add command -label "Dist.hkl" -command Cequ
.sbar.file.menu add cascade -label "Copy Files" -menu .sbar.file.menu.copy

menu .sbar.file.menu.copy -tearoff false
.sbar.file.menu.copy add cascade -label DAT0i.OUT -menu .sbar.file.menu.copy.o
.sbar.file.menu.copy add cascade -label DAT0i.END -menu .sbar.file.menu.copy.e
.sbar.file.menu.copy add cascade -label DATA.SPC  -menu .sbar.file.menu.copy.s
.sbar.file.menu.copy add command -label "All DAT0i.END" -command {CopyFile 6 0 0}
.sbar.file.menu.copy add separator
.sbar.file.menu.copy add command -label "Help" -command {WinHelp Copy}
menu .sbar.file.menu.copy.o -tearoff false
.sbar.file.menu.copy.o add command -label DAT01.OUT -command {CopyFile 0 1 0}
.sbar.file.menu.copy.o add command -label DAT02.OUT -command {CopyFile 0 2 0}
.sbar.file.menu.copy.o add command -label DAT03.OUT -command {CopyFile 0 3 0}
.sbar.file.menu.copy.o add command -label DAT04.OUT -command {CopyFile 0 4 0}
.sbar.file.menu.copy.o add command -label DAT05.OUT -command {CopyFile 0 5 0}
menu .sbar.file.menu.copy.e -tearoff false
.sbar.file.menu.copy.e add command -label DAT01.END -command {CopyFile 1 0 0}
.sbar.file.menu.copy.e add command -label DAT02.END -command {CopyFile 2 0 0}
.sbar.file.menu.copy.e add command -label DAT03.END -command {CopyFile 3 0 0}
.sbar.file.menu.copy.e add command -label DAT04.END -command {CopyFile 4 0 0}
.sbar.file.menu.copy.e add command -label DAT05.END -command {CopyFile 5 0 0}
menu .sbar.file.menu.copy.s -tearoff false
.sbar.file.menu.copy.s add command -label DAT01.OUT -command {CopyFile 0 0 1}
.sbar.file.menu.copy.s add command -label DAT02.OUT -command {CopyFile 0 0 2}
.sbar.file.menu.copy.s add command -label DAT03.OUT -command {CopyFile 0 0 3}
.sbar.file.menu.copy.s add command -label DAT04.OUT -command {CopyFile 0 0 4}
.sbar.file.menu.copy.s add command -label DAT05.OUT -command {CopyFile 0 0 5}

menu .sbar.ana.menu
.sbar.ana.menu add command -label Stat -command Main
.sbar.ana.menu add command -label Block -command Block
.sbar.ana.menu add command -label "Get Summary info" -command {.ed insert $pos "INFO\n"}
.sbar.ana.menu add command -label "Esd Transformation" -command { EsdT }
.sbar.ana.menu add command -label "Intensities distribution" -command { Intensity }
.sbar.ana.menu add command -label Histogram -command { Histogram }
.sbar.ana.menu add command -label Inconsistency -command { Inconsistency }

menu .sbar.sel.menu
.sbar.sel.menu add command -label "Special Conditions" -command SpecialCondition
.sbar.sel.menu add command -label "Select" -command Select
.sbar.sel.menu add command -label "List" -command ListReflections
.sbar.sel.menu add command -label "Search" -command SearchRef
.sbar.sel.menu add command -label "User's Conditions" -command UserSelect
.sbar.sel.menu add command -label "Exclusions" -command Exclude

menu .sbar.printing.menu
.sbar.printing.menu add command -label "Long output" -command {.ed insert $pos "LONG\n"}
.sbar.printing.menu add command -label "Summary only" -command {.ed insert $pos "SHOR\n0\n"}
.sbar.printing.menu add command -label "Printing cutoff" -command {PrintingCutoff}
.sbar.printing.menu add command -label "Min. num. of equiv. to print" -command {MinimumEqu} 
.sbar.printing.menu add command -label "Theta ordering" -command {.ed insert $pos "ORDT\n"}
.sbar.printing.menu add command -label "hkl ordering"  -command {.ed insert $pos "ORDH\n"}

menu .sbar.dele.menu
.sbar.dele.menu add command -label "Weak" -command {DeleteWeak 0}
.sbar.dele.menu add command -label "Special" -command {DeleteWeak 1}
.sbar.dele.menu add command -label "Excluded" -command {.ed insert $pos "DELX\n"}

menu .sbar.misc.menu
.sbar.misc.menu add command -label "Stop" -command {.ed insert $pos "STOP\n"}
.sbar.misc.menu add command -label "Flow" -command {.ed insert $pos "FLOW\n"}
.sbar.misc.menu add command -label "Sort list.hkl" -command {.ed insert $pos "SORT\n"}
.sbar.misc.menu add command -label "Merge" -command {Merge2}
.sbar.misc.menu add command -label "Ranking" -command {Rank}
.sbar.misc.menu add command -label "Discharge SIGMA buffer" -command {.ed insert $pos "SOUT\n"}
.sbar.misc.menu add command -label "Hyperlinks" -command {Hyper}
.sbar.misc.menu add command -label "Centro-symm. analysis" -command { CentroSymm }

menu .sbar.def.menu
.sbar.def.menu add command -label "Analysis" -command BuildDefault
.sbar.def.menu add command -label "Extiction Conditions" -command BuildConditions
.sbar.def.menu add command -label "hkl generation" -command BuildGeneration
.sbar.def.menu add command -label "hkl gen. with conditions (I)" -command GenCond2
.sbar.def.menu add command -label "hkl gen. with conditions (II)" -command GenCond

#Configure program menu bar (bottom)

frame .pbar -relief raised -bd 2
pack .pbar  -side right -fill x

button .pbar.tras -text Tras -width 5 -padx 4 -pady 4 -bd 2 -width 9 -relief raised
button .pbar.smart -text Smart -padx 4 -pady 4 -bd 2 -relief raised -width 9
button .pbar.proc -text Process -padx 4 -pady 4 -bd 2 -relief raised -width 9 -command {
         set equflag 0
         set equflag [catch {EquStat}]
         if {$equflag == 1} {
           set msg "*** Warning: Equstat ended with error(s)\n"
           catch {ConsoleWrite "color" $msg}
           .pbar.proc configure -relief raised
      }
}

button .pbar.copy -text "Copy hkl" -padx 4 -pady 4 -bd 2 -relief raised -width 9 -command DataCopy
button .pbar.view -text "ActiveView" -padx 4 -pady 4 -bd 2 -relief raised -width 9 -command ViewOutput
button .pbar.clear -text Clear -padx 4 -pady 4 -bd 2 -relief raised -width 9 -command ClearFile

bind .pbar.smart <Button-1> { SmartWindow }
bind .pbar.tras <Button-1>  { FormatTransform }
bind .ed <Button-3> {
     set pos insert 
     set msg "Board: insertion position changed to $pos\n"
     catch {ConsoleWrite "general" $msg}
}
bind .ed <Button-2> {
      set pos end
      set msg "Board: insertion position restored to $pos\n"
      catch {ConsoleWrite "general" $msg}
}

focus .ed 

bind . <Control-q>  { exit }
bind . <Control-w>  { WorkDir }
bind . <Control-c>  { ResetEditor } 
bind . <Control-p>  { catch {EquStat} }

if {$OS == "Unix"} {
  bind .ed <Control-t>  {exec xterm -e $cmd(tras)}
}
bind . <Control-s>  { SmartWindow }
bind . <Control-o>  { ViewOutput }
bind . <Control-f>  { Fill }
bind . <Control-r>  { Reset }
bind . <Control-h>  { DataCopy }
bind . <Control-b>  { Compute }
bind . <Control-d>  { ClearFile }

pack .pbar.copy  .pbar.tras .pbar.smart .pbar.proc .pbar.view .pbar.clear \
        -side left -fill x



