      program smart
c
c  Smart Program    *** Rel. 1.1 25/05/2001
c                            By M. Prencipe
c
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,pi2=0.017453292)
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1)
      open(4,file='temp.smart')
      open(5,file='smart.out')
      call readin
      call cella
      call calc
      call dist
      call out
      close(4)
      close(5)
      end
c
c  Readin routine
c
      subroutine readin
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,pi2=0.017453292)
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1)
      read(4,*)(apar(i),i=1,6)
      read(4,*)apar(7)  
      read(4,*)ctf
      return
      end
c
c cella routine: setup calculation for theta selection
c
      subroutine cella
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,pi2=0.017453292)
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1)
      a=apar(1)
      b=apar(2)
      c=apar(3)
      al=apar(4)*pi2
      be=apar(5)*pi2
      ga=apar(6)*pi2
      pa=(sin(al)/a)
      ap(1)=pa*pa
      pa=(sin(be)/b)
      ap(2)=pa*pa
      pa=(sin(ga)/c)
      ap(3)=pa*pa
      ca=cos(al)
      cb=cos(be)
      cg=cos(ga)
      ap(4)=(2./(a*b))*(ca*cb-cg)
      ap(5)=(2./(b*c))*(cb*cg-ca)
      ap(6)=(2./(c*a))*(cg*ca-cb)
      ap(7)=1-ca*ca-cb*cb-cg*cg+2.*ca*cb*cg
      return
      end
c
c Calc routine: main calculation
c
      subroutine calc
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,ndiv=999,
     *          pi2=0.017453292)
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1)
      common/dat2/afmin,afmax,aff(ndiv)
      common/idat2/iff(ndiv),ic,ico
      open(7,file='DATA.INP')
      ic=1
      ilz=0
  1   continue
      read(7,*)ih,ik,il,ff,ss
      call theta(ih,ik,il,th,jflag)
      if(jflag.eq.1)go to 1
      if(ic.eq.1)then
      tmin=th
      tmax=th
      else
      if(th.lt.tmin)tmin=th
      if(th.gt.tmax)tmax=th
      end if
      if(ff.lt.0.)ilz=ilz+1
      if(ff.lt.ctf)then
      ic=ic+1
      go to 1
      end if
      afmin=ff
      afmax=ff
      ico=1
 33   continue
      read(7,*,end=99)ih,ik,il,ff,ss
      if(ih.eq.0.and.ik.eq.0.and.il.eq.0) go to 33
      call theta(ih,ik,il,th,jflag)
      if(jflag.eq.1)go to 33
      if(th.lt.tmin)tmin=th
      if(th.gt.tmax)tmax=th
      ic=ic+1
      if(ff.lt.0.)ilz=ilz+1
      if(ff.lt.ctf)then
      go to 33
      end if
      if(ff.gt.afmax)afmax=ff
      if(ff.lt.afmin)afmin=ff
      ico=ico+1
      go to 33
  99  continue
      close(7)
      ic=ic-1
      ico=ico-1
      tminc=tmin/pi2
      tmaxc=tmax/pi2
      iflag=1
      df=1.
      if(abs(afmax-afmin).gt.1e-6)then
      df=ndiv/(afmax-afmin)
      iflag=0
      end if
      write(5,100)ic,tminc,tmaxc,ico,ctf,ilz,afmax,afmin
c     write(1,100)ic,tminc,tmaxc,ico,ctf,ilz,afmax,afmin
 100  format(/1x,i5,'  reflections read. Theta min.: ',f5.1,
     *       '   Theta max.: ',f5.1/
     *        1x,i5,'  reflections with int. higher than ',f5.1/
     *        1x,i5,'  reflections with int. less than 0.'/
     *        6x,'  Max. intensity: ',f7.1,'     Min. int.: ',f7.1)
      ran=(ipoin-1.)/(tmax-tmin)
      nic=ic/5
      do 3 i=1,ipoin
      aiv(i)=0.
 3    iv(i)=0
      do 22 i=1,ndiv
      aff(i)=0.
 22   iff(i)=0
      open(7,file='DATA.INP')
 34   continue
      read(7,*,end=2)ih,ik,il,ff,ss
      if(ih.eq.0.and.ik.eq.0.and.il.eq.0)go to 34
      call theta(ih,ik,il,th,jflag)
      if(jflag.eq.1)go to 34
      ipos=ran*(th-tmin)+1
      iv(ipos)=iv(ipos)+1
      aiv(ipos)=aiv(ipos)+th
      if(ff.lt.ctf)go to 34
      ifp=nint((ff-afmin)*df)
      if(ifp.gt.ndiv)ifp=ndiv
      if(ifp.le.0)ifp=1
      iff(ifp)=iff(ifp)+1
      aff(ifp)=aff(ifp)+ff
      go to 34
 2    continue
      close(7)
      do 43 i=1,ndiv
      if(iff(i).ne.0)then
      aff(i)=aff(i)/iff(i)
      end if
 43   continue
      ic2=0
      do 4 i=1,ipoin
      if(iv(i).ne.0) then
      ic2=ic2+1
      aiv2(ic2)=aiv(i)/iv(i)
      iv2(ic2)=iv(i)
      end if
 4    continue
      the(1,1)=tminc
      k=1
      do 5 i=1,4
      ive(i)=0
      do 6 j=k,ic2
      ive(i)=ive(i)+iv2(j)
      if(ive(i).gt.nic)then
      ival1=abs(ive(i)-iv2(j)-nic)
      ival2=ive(i)-nic
      if(ival1.gt.ival2)then
      the(i,2)=(aiv2(j)/pi2)+0.1
      the(i+1,1)=the(i,2)+0.00001
      k=j+1
      go to 5
      else
      ive(i)=ive(i)-iv2(j)
      the(i,2)=(aiv2(j-1)/pi2)+0.1
      the(i+1,1)=the(i,2)+0.00001
      k=j
      go to 5
      end if
      end if
 6    continue
 5    continue
      ive(5)=ic
      do 7 i=1,4
 7    ive(5)=ive(5)-ive(i)
      the(5,2)=tmaxc
      write(5,300)nic,the(1,1),the(1,2),ive(1),
     *                the(2,1),the(2,2),ive(2),
     *                the(3,1),the(3,2),ive(3),
     *                the(4,1),the(4,2),ive(4),
     *                the(5,1),the(5,2),ive(5)
c     write(1,300)nic,the(1,1),the(1,2),ive(1),
c    *                the(2,1),the(2,2),ive(2),
c    *                the(3,1),the(3,2),ive(3),
c    *                the(4,1),the(4,2),ive(4),
c    *                the(5,1),the(5,2),ive(5)

 300  format(/' Number of vectors per group: ',i4//
     *' 1) theta min.= ',f9.3,'  theta max.= ',f9.3,'   vect. ',i5/
     *' 2) theta min.= ',f9.3,'  theta max.= ',f9.3,'   vect. ',i5/
     *' 3) theta min.= ',f9.3,'  theta max.= ',f9.3,'   vect. ',i5/
     *' 4) theta min.= ',f9.3,'  theta max.= ',f9.3,'   vect. ',i5/
     *' 5) theta min.= ',f9.3,'  theta max.= ',f9.3,'   vect. ',i5)
      return
      end
c
c  dist routine: distribution of intensities
c
      subroutine dist
      implicit double precision(a-h,o-z)
      parameter(ndiv=999,iscal=10)
      common/dat2/afmin,afmax,aff(ndiv)
      common/idat2/iff(ndiv),ic,ico
      common/dat3/afin(iscal),aff2(ndiv)
      common/idat3/jscal,ifin(iscal),iff2(ndiv)
      icc=0
      do 5 i=1,ndiv
      if(iff(i).ne.0)then
      icc=icc+1
      iff2(icc)=iff(i)
      aff2(icc)=aff(i)
      end if
  5   continue
      do 1 i=1,iscal
      ifin(i)=0
  1   afin(i)=0.
      nr=ico/iscal
      ini=1
      jscal=0
      do 2 i=1,iscal
      inc=1
      jscal=jscal+1
      do 3 j=ini,icc
      ifin(i)=ifin(i)+iff2(j)
      if(ifin(i).ge.nr)then
      afin(i)=aff2(j)
      ini=inc+ini
      go to 2
      end if
      inc=inc+1
 3    continue
      afin(i)=aff2(j-1)
      goto 6
 2    continue
 6    continue
      write(5,100)jscal,nr,(ifin(i),i=1,jscal)
      write(5,150)(afin(i),i=1,jscal)
c     write(1,100)jscal,nr,(ifin(i),i=1,jscal)
c     write(1,150)(afin(i),i=1,jscal)
 100  format(/' Distribution of intensities on ',i3,' intervals:'/
     *        ' Mean num. of refl. for group: ',i6//
     *        ' N: ',7(i6,1x),3(i8,1x))
 150  format(' I:  ',7(f6.0,1x),3(f8.0,1x))
      return
      end
c
c theta routine: selects reflections with given theta
c
      subroutine theta(jh,jk,jl,th,jflag)
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,pi2=0.017453292)
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1) 
      al2=apar(7)*.5
      dm=jh*jh*ap(1)+jk*jk*ap(2)+jl*jl*ap(3)+jh*jk*ap(4)+
     *   jk*jl*ap(5)+jl*jh*ap(6)
      di2=dm/ap(7)
      di=sqrt(di2)*al2
      if(di.le.0.99999)then
      th=asin(di)
      jflag=0
      else
      jflag=1
      end if
      return
      end
c
c out routine: provides info.inp file
c
      subroutine out
      implicit double precision(a-h,o-z)
      parameter(maxc=100,ipoin=2000,ip1=ipoin+10,iscal=10,
     *          ndiv=999)
      parameter(iev=8,iun=1,idu=2,itr=3,isi=6,izer=0)
      character*80 titl,sym(32)*10,isym*10,key(14)*10
      common/dati/apar(7),ap(7),aiv(ip1),aiv2(ip1),the(5,2),ctf
      common/idati/iv(ip1),iv2(ip1),ive(ip1)
      common/dat2/afmin,afmax,aff(ndiv)
      common/idat2/iff(ndiv),ic,ico
      common/dat3/afin(iscal),aff2(ndiv)
      common/idat3/jscal,ifin(iscal),iff2(ndiv)
      data (sym(i),i=1,17) / 'm-3m','-3','-3m1','4/mmm','mmm','-31m',
     *                  '6/m','6/mmm','2/m','432','-43m','m-3','23',
     *                  '4/m','2','m','-1'/
      data (key(i),i=1,14)/ 'TITL','CELL','SYMM','EVAL','THET',
     *                      'COPY','STAT','INFO','SETZ','WEAK',
     *                      'SHOR','INTS','SIGM','ORDT'/
      read(4,200)titl
 200  format(a80)
      read(4,400)isym
 400  format(a10)
      ism=1
      do 1 i=1,17
      if(isym.eq.sym(i))then
      ism=i
      go to 2
      end if
  1   continue
  2   continue
      read(4,*)perc
      read(4,*)cot
      read(4,*)acot
      icot=nint(acot)
      open(8,file='info.inp')    
      write(8,700)key(1),titl,key(2),(apar(i),i=1,7),key(3),
     *            ism,key(4),iev,izer
  700 format(a4/a80/a4/6f9.3,f9.6/a4/i3/a4/2i6)
      the(1,1)=the(1,1)-0.5
      the(5,2)=the(5,2)+0.5
      do 3 i=1,5
      write(8,705)key(5),the(i,1),the(i,2),i
  705 format(a4/2f11.5,i4)
   3  continue
      if(icot.ne.0)then
      write(8,915)key(11),icot,key(14)
  915 format(a4/i4/a4)
      else
      write(8,916)key(14)
  916 format(a4)
      end if
      do 4 i=1,5
      write(8,710)key(6),izer,i,izer,key(7),iun,iun,iun,
     *            izer,idu,perc,cot
   4  continue
  710 format(a4/3i4/a4/4i4/i4,2f6.1)
      write(8,715)key(8),key(9),key(10),iev,key(11),izer
  715 format(a4/a4/a4/i4/a4/i4)
      write(8,720)key(6),isi,izer,izer,key(12),jscal,
     *            (afin(i),i=1,jscal)
  720 format(a4/3i4/a4/i2,3f6.0,2f7.0,3f8.0,2f9.0)
      write(8,725)key(13),iun,itr,idu
  725 format(a4/3i4)
      do 5 i=1,5
      write(8,710)key(6),izer,i,izer,key(7),izer,izer,iun,
     *            izer,izer,perc,cot
   5  continue
      close(8)
      write(5,800)
c     write(1,800)
 800  format(//' Smart ended, file info.inp generated.'/)
      return
      end
